<?php
/**
 * Copyright (c) 2019 Unbxd Inc.
 */

/**
 * Init development:
 * @author andy
 * @email andyworkbase@gmail.com
 * @team MageCloud
 */
namespace Unbxd\Analytics\Model;

/**
 * Class Config
 * @package Unbxd\Analytics\Model
 */
class Config
{
    /**
     * Analytics version (send as parameter of API request for separate events)
     */
    const ANALYTICS_VERSION       = '2.8.22';

    /**#@+
     * Constants for param keys of API request.
     */
    const PARAM_DATA                    = 'data';
    const PARAM_CATEGORY_PAGE           = 'page';
    const PARAM_CATEGORY_PAGE_TYPE      = 'page_type';
    const PARAM_PRODUCT_ID              = 'pid';
    const PARAM_VARIANT_ID              = 'variantId';
    const PARAM_PRODUCT_QTY             = 'qty';
    const PARAM_PRODUCT_PRICE           = 'price';
    const PARAM_CURRENT_URL             = 'url';
    const PARAM_REFERRER_URL            = 'referrer';
    const PARAM_VISIT_TYPE              = 'visit_type';
    const PARAM_VISIT_ID                = 'visitId';
    const PARAM_SITE_KEY                = 'UnbxdKey';
    const PARAM_ACTION                  = 'action';
    const PARAM_CUSTOMER_ID             = 'uid';
    const PARAM_TIME                    = 't';
    const PARAM_VERSION                 = 'ver';
    /**
     * extra parameters
     */
    const PARAM_QUERY   = 'query';
    const PARAM_PAGE    = 'page';
    /**#@-*/

    /**#@+
     * Constants for cookies name generated by unbxdAnalytics.js.
     */
    const COOKIE_USER_ID        = 'unbxd_userId';
    const COOKIE_VISIT_ID       = 'unbxd_visitId';
    const COOKIE_VISIT_TYPE     = 'unbxd_visit';
    /**#@-*/

    /**
     * Analytics API default endpoint (will be used if related endpoint are not specified in config fields)
     */
    const ANALYTICS_API_ENDPOINT_DEFAULT = 'http://tracker.unbxdapi.com/v2/1p.jpg';

    /**
     * API request type related to analytics
     */
    const API_REQUEST_TYPE_ANALYTICS = 'analytics';
}